#include "devicevibrator.h"

DeviceVibrator::DeviceVibrator(QObject *parent) :
    QObject(parent)
{
    this->actuator = new QtMobility::QFeedbackActuator(this);
    this->hapticsEffect = new QtMobility::QFeedbackHapticsEffect(this);

    this->hapticsEffect->setActuator(this->actuator);

    this->hapticsEffect->setDuration(250);
}

DeviceVibrator::~DeviceVibrator(){
    delete actuator;
    delete hapticsEffect;
}

///
///Returns true if this system has valid actuators that can be used
///If returns false, DON'T USE THIS CLASS ANY FURTHER
///
bool DeviceVibrator::isValid()
{
    return this->actuator->isValid();
}

///
///Causes rumble with the given strength-type
///
void DeviceVibrator::rumble(RumbleStrength::rStrength_t str)
{
    if(this->hapticsEffect->state() == QtMobility::QFeedbackEffect::Stopped){
        switch(str){
            case RumbleStrength::WEAK:
                this->hapticsEffect->setIntensity(0.3);
                break;
            case RumbleStrength::MEDIUM:
                this->hapticsEffect->setIntensity(0.7);
                break;
            case RumbleStrength::STRONG:
                this->hapticsEffect->setIntensity(1);
                break;
            default:
                //as default, medium strength
                this->hapticsEffect->setIntensity(0.7);
                break;
        }
        this->hapticsEffect->start();
    }
}

///
///Without params, this function causes mid-level rumble
///
void DeviceVibrator::rumble(){
    if (this->hapticsEffect->state() == QtMobility::QFeedbackEffect::Stopped)
        this->hapticsEffect->setIntensity(0.7);
        this->hapticsEffect->start();
}
//asd
