#ifndef GAMELOGIC_H
#define GAMELOGIC_H

#include <QObject>
#include <qmlapplicationviewer.h>
#include <QTimer>
#include <QQueue>
#include "singleton.h"
class GameLogic : public QObject, public Singleton<GameLogic> {
    Q_OBJECT

    QTimer* mainLoopTimer;
    QmlApplicationViewer* viewer;

    QQueue<QString> waypoints;

    // Accelerometer stuff
    qreal accelerometerAccumulator;

    QString state;
    qreal skyOpacity;

    int penalty;

    qreal signalPercentage;

public:
    explicit GameLogic(QObject *parent = 0);
    ~GameLogic();

    void initialize(QmlApplicationViewer* qav);
    QQueue<QString>& getWayPoints();
signals:

public slots:
    void mainLoop();
    Q_INVOKABLE qreal getSkyOpacity();
    Q_INVOKABLE QString getState();
    Q_INVOKABLE qreal getSignalPercentage();
private:

    bool evaluateAccelerometerData();
    bool evaluateDeviceMapData(QMap<QString,qint16> &deviceMap);
};

#endif // GAMELOGIC_H
