#include <QtGui/QApplication>
#include "qmlapplicationviewer.h"
#include <QDeclarativeContext>
#include "gamelogic.h"
#include "accelerometer.h"
#include "devicevibrator.h"
#include "scorecalculator.h"
#include "bluetooth.h"
#include <QSystemScreenSaver>
Q_DECL_EXPORT int main(int argc, char *argv[])
{
    QScopedPointer<QApplication> app(createApplication(argc, argv));
    QScopedPointer<QmlApplicationViewer> viewer(QmlApplicationViewer::create());

    QtMobility::QSystemScreenSaver *sss=new QtMobility::QSystemScreenSaver (app.data());
    sss->setScreenSaverInhibited(true);

    Accelerometer::init(0);
    Bluetooth::init(0);
    ScoreCalculator::init(0);
    DeviceVibrator::init(0);
    Bluetooth::instance()->update();
    GameLogic::init(0);
    GameLogic::instance()->initialize(viewer.data());

    viewer->rootContext()->setContextProperty("GameLogic", GameLogic::instance());
    viewer->setOrientation(QmlApplicationViewer::ScreenOrientationLockPortrait);
    viewer->setMainQmlFile(QLatin1String("qml/ProjectHuuhkaja/main.qml"));
    viewer->showExpanded();

    int returnCode = app->exec();
    qDebug("WUT");
    GameLogic::destroy();
    Bluetooth::destroy();
    Accelerometer::destroy();
    DeviceVibrator::destroy();
    ScoreCalculator::destroy();

    sss->setScreenSaverInhibited(false);

    return returnCode;
}
