import QtQuick 1.0

Item {
    id: progressbar

    property real minimum: 0
    property real maximum: 1
    property real percentage: 0.5
    property color color: "#77B753"

    width: 300; height: 23
    clip: true

    Rectangle {
        id: border
        anchors.fill: parent
        anchors.bottomMargin: 1
        anchors.rightMargin: 1
        color: "transparent"
        border.width: 1
        border.color: parent.color
    }

    Rectangle {
        id: highlight
        property int widthDest: ( ( progressbar.width * ( percentage - minimum ) ) / ( maximum - minimum ) - 4 )
        width: highlight.widthDest

        Behavior on width {
            SmoothedAnimation {
                velocity: 1200
            }
        }

        anchors {
            left: parent.left
            top: parent.top
            bottom: parent.bottom
            margins: 2
        }
        color: parent.color
    }
}
