import QtQuick 1.0

Rectangle {

    anchors.fill: parent
    id: game
    property string spriteSource: "pingu2.png"
    property int spriteFrameCount: 1

    state: "SPLASH"
    property real sky : GameLogic.getSkyOpacity()
    property real btPercentage: GameLogic.getSignalPercentage()
    property string bgSource : "menutausta.png"

    Timer {
        id: updateUI
        interval: 10
        running: true
        repeat: true
        onTriggered: {
            if(game.state != "SPLASH"){
                bgSource = "pingutausta2.png"
            }

            if(game.state != "SPLASH" && game.state != "WAYPOINT" && game.state != "VICTORY"){
                state=GameLogic.getState()
                sky = GameLogic.getSkyOpacity()
                btPercentage = GameLogic.getSignalPercentage()
            }
        }
    }

    MouseArea{
        anchors.fill: parent
        onClicked: {
            if(game.state == "SPLASH" || game.state == "WAYPOINT")
                game.state = "NORMAL"
        }
    }



    states:[

        State {
            name: "NORMAL"
            PropertyChanges {
                target: game
                spriteSource: "pingu2.png"
                spriteFrameCount: 1

            }
        },

        State {
            name: "HAPPY"
            PropertyChanges {
                target: game
                spriteSource: "pinguhappy2.png"
                spriteFrameCount: 1

            }
        },

        State {
            name: "VICTORY"
            PropertyChanges {
                target: game
                spriteSource: "youwin.png"
                spriteFrameCount: 1

            }
        },

        State {
            name: "FAIL"
            PropertyChanges {
                target: game
                spriteSource: "pingucrash2.png"
                spriteFrameCount: 1

            }
        },

        State{
            name: "SPLASH"
            PropertyChanges {
                target: game
                spriteSource: "findme.png"
                spriteFrameCount: 1

            }
        },

        State{
            name: "WAYPOINT"
            PropertyChanges {
                target: game
                spriteSource: "sirkus2.png"
                spriteFrameCount: 1

            }
        }

    ]

    Behavior {
             ColorAnimation { target: game; duration: 100 }
         }

    Background{
        backgroundSource: bgSource
        bgOpacity : sky
    }

    Sprite{
        id: img1
        clip: false
        source: spriteSource
        running: false
        frameCount: spriteFrameCount
    }

    Button{
        id: quitButton
        label: "X"
        buttonWidth: 30
        buttonHeight: 30
        buttonColorTop: "red"
        buttonColorBottom: "darkgrey"
        onButtonClick: {
            Qt.quit()
        }
    }

    BluetoothMeter{
        anchors.right: parent.right
        anchors.rightMargin: 15
        anchors.left: parent.left
        anchors.leftMargin: 15
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 20
        percentage: btPercentage
    }

}
