#ifndef SCORECALCULATOR_H
#define SCORECALCULATOR_H

#include <QObject>
#include <QMutex>
#include <QtGlobal>
#include <QTimer>
#include <QMap>
#include <QQueue>
#include <QString>
#include "singleton.h"
#include "accelerometer.h"
#include "bluetooth.h"

//This class is just an experiment, and it's possible it's not implemented in the final version.

class ScoreCalculator : public QObject, public Singleton<ScoreCalculator>
{
    Q_OBJECT
public:
    explicit ScoreCalculator(QObject *parent = 0);
    virtual ~ScoreCalculator();
    qint16 getScore();

private:
    void evaluateDeviceMapData(QMap<QString, qint16> &deviceMap);

    QMutex *scoreLock;
    QTimer *scoreTimer;
    qint16 score;
signals:

private slots:
    void modifyScore();

public slots:
    void start();
    void stop();
};

#endif // SCORECALCULATOR_H
